/*
	Template Instructions:
	
	Search for "Rectangle", and edit as needed with consideration of your class name
	NOTE WELL -- look carefully if test case class name or model class name is needed.
*/

/*
	File: model-test-case.js
	Class: RectangleTestCase	
	
	//framework
	1) Code tagged with the tag //framework requires
	a minor edit or no edit (comment by tag will inform)
	2) The expression "extends superClass" below is also
	part of the framework support (no edit required)
*/

//framework -- test case name
addTestCase("RectangleTestCase");

class RectangleTestCase extends TestCase {
	//ivars: unit
	
	//-----------------
	//Unit Test Support		
	
	getUnitName() {
		//framework -- model type (class)
		return 'Rectangle';
	}	
	
	//-----------------
	//Setup	
	
	beforeEach() {
		//Called before each test for test setup (if needed)
		//Construct a unit model for testing (we use `lk`cf.ivar "unit")
		super.beforeEach();		
		//framework - construct your model (testee) here.
		//NOTE WELL -- this method is optional (see "ALTERNATIVE #2" below)
		//in your "test*" methods, and test that instance.
		this.unit = new Rectangle(10, 5);
	}	
	
	//-----------------
	//Tests
	
	//TODO -- tests here (names need to start with test*
	//One test is left here for reference
	
	/*
	ALTERNATIVE #1 (using "beforeEach" above)
	testGetWidth() {
		//Test that the unit (testee) returns width as expected (10) for `bq`"getWidth"
		this.assertEquals(10, this.unit.getWidth());
	}
		
	ALTERNATIVE #2 (constructig model/testee in test itself)
	testGetWidth() {
		//Test that the unit (testee) returns width as expected (10) for `bq`"getWidth"
		const rec = new Rectangle(8, 7);
		this.assertEquals(8, rec.getWidth());
	}		
	*/
	
	
	/*
	WE CAN ALSO TEST strings in tests like this example
	testMessage1() {
		const rec = this.unit;
		//Force an error
		rec.setWidth(-100);
		//we expect word "error" in message with negative width
		this.assertEquals(true, rec.getMessage().toLowerCase().includes('error'));
	}		
	*/

} 

